const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const maintenance_tickets = sequelize.define(
    'maintenance_tickets',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

priority: {
        type: DataTypes.ENUM,

        values: [

"low",

"medium",

"high",

"urgent"

        ],

      },

status: {
        type: DataTypes.ENUM,

        values: [

"open",

"in_progress",

"resolved"

        ],

      },

title: {
        type: DataTypes.TEXT,

      },

description: {
        type: DataTypes.TEXT,

      },

photos_json: {
        type: DataTypes.TEXT,

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  maintenance_tickets.associate = (db) => {

    db.maintenance_tickets.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.maintenance_tickets.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return maintenance_tickets;
};

